//
// Created by illyum on 8/16/2024.
//

#ifndef SERIAL_PORT_FACTORY_H
#define SERIAL_PORT_FACTORY_H

#include "serial_port.h"

#ifdef _WIN32
#include "serial_port_windows.cpp"
typedef WindowsSerialPort PlatformSerialPort;
#elif defined(__linux__) || defined(__APPLE__)
#include "serial_port_posix.cpp"
typedef PosixSerialPort PlatformSerialPort;
#endif

class SerialPortFactory {
public:
    static SerialPort* createSerialPort() {
        return new PlatformSerialPort();
    }
};

#endif // SERIAL_PORT_FACTORY_H
